#ifndef XPARTICLES_SYSTEM_H
#define XPARTICLES_SYSTEM_H

#include "particles_system.h"
#include <d3dx9.h>

// structure of vertex for the torus
struct PARTICLE_VERTEX
{
	FLOAT x,y,z;          // coordonnes de la particule	
	FLOAT fade;
};


class XParticles_System : public Particles_System
{
public:
	XParticles_System(LPDIRECT3DDEVICE9 pDevice , int n , int s);
	HRESULT fillVertexBuffer();
	LPDIRECT3DVERTEXBUFFER9 getVertexBuffer() { return g_pVB_Particles;}
private:
	LPDIRECT3DVERTEXBUFFER9 g_pVB_Particles;

};

#endif