#include <windows.h>
#include <mmsystem.h> // fonction time (winmm.lib)

#include "mytools_time.h"

Timer::Timer()
{
	LARGE_INTEGER timer;
    QueryPerformanceCounter(&timer);
	tinit = (double)timer.QuadPart;

	LARGE_INTEGER freq;
    QueryPerformanceFrequency(&freq); 
	tfreq = (double)freq.QuadPart;
}

void Timer::Reset()
{
	LARGE_INTEGER timer;
    QueryPerformanceCounter(&timer);
	tinit = (double)timer.QuadPart;

	LARGE_INTEGER freq;
    QueryPerformanceFrequency(&freq); 
	tfreq = (double)freq.QuadPart;

}

double Timer::GetTime(void) 
{
	LARGE_INTEGER timer;
    QueryPerformanceCounter(&timer);	
	double time = (double)timer.QuadPart;

	return (time-tinit)/tfreq;
}
