#include "particles_system.h"

#include <iostream>
using namespace std;


#define X0  0.5f
#define Y0  0.0f
#define Z0  0.5f

#define V0Y  4.0f   //4.0
#define V0XZ 0.5f
#define gravity 9.81f  //9.81
#define fade_speed 0.0001f


/*--------------------------------------------------------------------------*/
Particles_System::Particles_System(int n,int s)
{
	t.Reset();
	//Particle p;		
	transitoire = true;
	nb_particles_final = n;
	speed_add = s;
	/*
	for(int i=0;i<n;++i)			
		particules.push_back(p);	
	*/
}

/*--------------------------------------------------------------------------*/
void Particles_System::Init()
{
	//std::vector<Particle>::iterator itr;
	t.Reset();	
	nb_particles = 0;
	/*
	int n=0;
	for( itr=particules.begin() ; itr != particules.end() ; itr++)
	{
		(*itr).t0 = tinit;
		(*itr).x0 =  (*itr).x = X0;
		(*itr).y0 =  (*itr).y = X0;
		(*itr).z0 =  (*itr).z = X0;
		(*itr).vx0 = (Rnd.Get_Float()-0.5f)*0.1f;
		(*itr).vy0 = 0.3f;
		(*itr).vz0 = (Rnd.Get_Float()-0.5f)*0.1f;
	}*/

}

/*--------------------------------------------------------------------------*/
void Particles_System::Display()
{
	std::vector<Particle>::iterator itr;
	int n=0;
	for( itr=particules.begin() ; itr != particules.end() ; itr++)
	{
		cout << "particule : \n";
		cout << (*itr).x << "  ,  " << (*itr).y << "  ,  " << (*itr).z <<"\n";
	}	
}

/*--------------------------------------------------------------------------*/
void Particles_System::Update()
{
	// on commence par mettre  jour celles existantes
	std::vector<Particle>::iterator itr;
	float time = t.GetTime();
	float dt;
	for( itr=particules.begin() ; itr != particules.end() ; itr++)
	{
		dt = time - (*itr).t0;
		(*itr).x =  (*itr).x0  + (*itr).vx0*dt;
		(*itr).y =  (*itr).y0  + (*itr).vy0*dt - 0.5*gravity*dt*dt;
		(*itr).z =  (*itr).z0  + (*itr).vz0*dt;
		/*
		(*itr).fade -= fade_speed;
		if((*itr).fade < 0)
			(*itr).fade =0.0f;*/

		if( (*itr).y < 0.0 )
		{			
			(*itr).t0 = time;
			(*itr).x0 =  (*itr).x = X0;
			(*itr).y0 =  (*itr).y = Y0+Rnd.Get_Float()*0.1;
			(*itr).z0 =  (*itr).z = Z0;
			(*itr).vx0 = (Rnd.Get_Float()-0.5f)*V0XZ;
			(*itr).vy0 = V0Y*(Rnd.Get_Float()/10.+1.0f);
			(*itr).vz0 = (Rnd.Get_Float()-0.5f)*V0XZ;
			(*itr).fade = 1.0f;
		}		
	}	

	//le nb qu'on devrait avoir
	int to_add=0;
	int to_have = time * speed_add;
	if(to_have <= nb_particles_final)
		to_add= to_have-nb_particles;

	Particle p;	
	for(int k=0;k<to_add;k++)
	{
		p.t0 = time;
		p.x0 =  p.x = X0;
		p.y0 =  p.y = Y0+Rnd.Get_Float()*0.1;
		p.z0 =  p.z = Z0;
		p.vx0 = (Rnd.Get_Float()-0.5f)*V0XZ;
		p.vy0 = V0Y*(Rnd.Get_Float()/10.+1.0f);
		p.vz0 = (Rnd.Get_Float()-0.5f)*V0XZ;	
		p.fade = 1.0f;
		particules.push_back(p);
		nb_particles++;

	}	
	

}
