#ifndef PARTICLES_SYSTEM
#define PARTICLES_SYSTEM

#include <vector>
#include "mytools_time.h"
#include "gen_rnd.h"

struct Particle
{
	float x0,y0,z0;
	float x,y,z;
	float vx0,vy0,vz0;
	float t0;
	float fade;
};

class Particles_System
{
public:
	Particles_System(int n, int s);
	void Init();
	void Display();
	void Update();
	int getNumberParticles() { return nb_particles;}
protected:
	std::vector<Particle> particules;
	Timer t;
	cRnd_Number_Generator Rnd;
	bool transitoire;
	// nb elt  rajouter par seconde
	int speed_add;
	int nb_particles;
	int nb_particles_final;
};

#endif